#####################################################################
# 
# ZScheduler -- Zope Scheduled Event Product
# Copyright (C) 2000 iCompression, Inc.
#
# Based on code by Martijn Pieters, (c) 1999 Antraciet B.V.
# Used with explicit permission.
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License  
# along with this program; if not, write to the 
#     Free Software Foundation, Inc., 
#     59 Temple Place - Suite 330, 
#     Boston, MA  02111-1307, USA.
# 
#####################################################################
""" Zope Scheduler (ZScheduler) Product """

import Loggerr
loggerr=Loggerr.loggerr

import ZSchedule
ScheduleID=ZSchedule.ScheduleID
ScheduleChange=ZSchedule.ScheduleChange

import ZEvent       
import Dispatcher

from Globals import ImageFile
from threading import Thread

#import pdb; pdb.set_trace()

# We only want one instance of the ZSchedule class,
# therefore we're not using registerClass
# Because no registerClass, 
# use the old method to set the icon for the ZSchedule object
misc_ = { 'ZScheduleIcon': ImageFile('www/ZSchedule.gif', globals()) }

def initialize(context):
  try:
    # Add the schedule catalog to the Zope root, 
    app = context._ProductContext__app

    global Schedule
    if hasattr(app, ScheduleID):
      #loggerr(0, 'Found existing '+ScheduleID)
      Schedule = getattr(app, ScheduleID, None)
    else:
      loggerr(0, 'Starting to create '+ScheduleID)
      try: # creating Schedule index
        oSchedule=ZSchedule.ZSchedule(id=ScheduleID, title='ZEvent Catalog')
        app._setObject(ScheduleID, oSchedule)
        loggerr(0, 'Created new '+ScheduleID)
      except: # if you can't create the index, tell someone.
        loggerr(200, 'Failed to create new '+ScheduleID)
      Schedule = getattr(app, ScheduleID, None)

    assert Schedule is not None

    # register ZEvent class
    #loggerr(0, 'Starting to register event class.')
    try: 
      context.registerClass(
        ZEvent.OneTimeZEvent,
        permission = 'Add ZEvent',
        constructors = (
          ZEvent.manage_addOneTimeZEventForm,
          ZEvent.manage_addOneTimeZEvent),
        icon = 'www/OneTimeZEvent.gif')
      context.registerBaseClass(ZEvent.OneTimeZEvent)
    except: # if you can't register the class, tell someone.
      loggerr(200, 'Failed to register ZEvent class.')
      import sys, traceback, string
      type, val, tb = sys.exc_info()
      sys.stderr.write(string.join(
        traceback.format_exception(type, val, tb), ''))
      del type, val, tb    

    context.registerBaseClass(ZEvent.OneTimeZEvent)

    # Start the Dispatcher thread
    dispatcher=Thread(target=Dispatcher.Timer, name='ZEventTimer', 
        args=(ScheduleID, ScheduleChange))
    dispatcher.start()

  except:
    import traceback
    traceback.print_exc()
